#ifndef LINUX_SLAB_BACKPORT_H
#define LINUX_SLAB_BACKPORT_H

#include_next <linux/slab.h>

/* kzalloc (introduced in 2.6.14) */
static inline void *kzalloc(size_t size, gfp_t flags)
{
	void *ret = kmalloc(size, flags);
	if (ret)
		memset(ret, 0, size);
	return ret;
}

#endif
#include_next <linux/slab.h>

#ifndef BACKPORT_LINUX_STRING_TO_2_6_18
#define BACKPORT_LINUX_STRING_TO_2_6_18

static inline
void *kmemdup(const void *src, size_t len, gfp_t gfp)
{
       void *p;

       p = kmalloc(len, gfp);
       if (p)
               memcpy(p, src, len);
       return p;
}

#endif
#ifndef BACKPORT_LINUX_STRING_TO_2_6_18
#define BACKPORT_LINUX_STRING_TO_2_6_18

static inline
void *kmemdup(const void *src, size_t len, gfp_t gfp)
{
       void *p;

       p = kmalloc(len, gfp);
       if (p)
               memcpy(p, src, len);
       return p;
}

#endif
